<script setup lang="ts">
import { type User } from '@/types/User'
import { useAuthStore } from '@/stores/auth'
import { nextTick, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import UserCard from './UserCard.vue'

const props = defineProps<{
  users: User[]
}>()
const emit = defineEmits<{
  selectedUser: [User]
}>()

function selected(p: User) {
  emit('selectedUser', p)
}

const authStore = useAuthStore()

let editedIndex = -1
const editedUser = ref<User>(JSON.parse(JSON.stringify(authStore.nonUser)))
const userss = ref<User[]>([])
userss.value = authStore.users
const dialog = ref(false)
const form = ref(false)
const loading = ref(false)
const refform = ref<VForm | null>(null)
let lastestId = 1
let latestId = 1
userss.value.forEach((user) => {
  if (user.id > lastestId) {
    latestId = user.id
  }
})
lastestId = latestId + 1

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, authStore.nonUser)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  editedUser.value.id = lastestId++
  userss.value.push(editedUser.value)
  closeDialog()
}

const roles = ['admin', 'user']
</script>
<template>
  <div style="position: relative; overflow-y: auto">
    <v-toolbar flat style="background-color: #212121; color: white">
      <v-toolbar-title>Employee</v-toolbar-title>
    </v-toolbar>

    <v-dialog v-model="dialog" persistent width="1024">
      <template v-slot:activator="{ props }">
        <v-btn v-bind="props" color="#c7a17a" class="new-user-btn"> New User </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">User</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
            <v-container>
              <v-row>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field
                    v-model="editedUser.email"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    class="mb-2"
                    clearable
                    label="Email"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="6">
                  <v-text-field
                    v-model="editedUser.fullname"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    class="mb-2"
                    clearable
                    label="Full Name"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="5" md="6">
                  <v-text-field
                    v-model="editedUser.username"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    class="mb-2"
                    clearable
                    label="Username"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="5" md="6">
                  <v-text-field
                    v-model="editedUser.password"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    class="mb-2"
                    clearable
                    label="Password"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="12" md="2">
                  <v-combobox
                    v-model="editedUser.gender"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    :items="[
                      { title: 'Male', value: 'male' },
                      { title: 'Female', value: 'female' },
                      { title: 'Others', value: 'others' }
                    ]"
                    label="Gender"
                    :return-object="false"
                  ></v-combobox>
                </v-col>

                <v-col cols="12" sm="12" md="3">
                  <v-combobox
                    v-model="editedUser.roles"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Please fill data']"
                    :items="roles"
                    label="Roles"
                    multiple
                    chips
                  ></v-combobox>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
          <small style="color: red">*Please fill data</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
          <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-container>
      <v-row>
        <v-col cols="12" md="3" v-for="item of users" :key="item.id">
          <UserCard :user="item" @selected-user="selected"></UserCard>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<style scoped>
.new-user-btn {
  position: relative;
  margin-top: 1%;
  left: 90%;
  margin-bottom: 20px;
}
</style>
